// BMS_CONVERTER wb_t@C
#ifndef _BMS_CONVERTER_H_
#define _BMS_CONVERTER_H_

#include "bmsfel.h"
#include "ttwav.h"
#include "ttl.h"

class BmsConverter {
protected:
  BmsBms *bms;
  char *bms_path;
  int master_volume;
  bool (* callback)( int );
  bool (* wav_file_empty_callback)( char * );
  TtWindow *wnd;
  bool (TtWindow::*wnd_callback)( int );
  TtWindow *wnd_wav_empty;
  bool (TtWindow::*wnd_wav_file_empty_callback)( char * );

  bool debug;
  char last_error_filename[1024];
  
public:
  BmsConverter();
  ~BmsConverter();
  void set_bms_path( char *bms_path );
  void set_debug( bool flag );
  BmsBms* open_bms();
  void set_master_volume( int volume );
  void set_callback( bool (* callback)( int ) );
  void set_wav_file_empty_callback( bool (* wav_file_empty_callback)( char * ) );
  void set_wnd_callback( TtWindow *wnd, bool (TtWindow::*wnd_callback)( int ) );
  void set_wnd_wav_file_empty_callback( TtWindow *wnd, bool (TtWindow::*wnd_wav_file_empty_callback)( char * ) );
  TtWav *convert();
  char *get_last_error_filename();
};

#endif // _BMS_CONVERTER_H_
